/* sockfp.c - \Pbgt@CXg[Ɋ֘AÂ

   ẼCu WSAStartup(), WSACleanup() ̌Ăяo͍sȂB
   EVC++ŃRpCWin9Xł͓ȂBsock2fp()̃RgQ
   Eclientsock(), acceptfp() ԂꂽXg[͒P fclose() 
     ΂悢Bfclose()  \PbgN[YĂB
*/
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <winsock.h>

/* w肳ꂽhost,portɐڑ */
static BOOL connectto(const char* host, int port, SOCKET sock)
{
	SOCKADDR_IN addr;
	DWORD ip = inet_addr(host);
	if (ip == INADDR_NONE) {
		struct hostent* pHost = gethostbyname(host);
		if (pHost == NULL)
			return FALSE;
		ip = *((DWORD*)(pHost->h_addr));
	}
	addr.sin_family = AF_INET;
	addr.sin_port = htons((unsigned short)port);
	addr.sin_addr.s_addr = ip;

	return (connect(sock, (const struct sockaddr*)&addr, sizeof addr)
			!= SOCKET_ERROR) ? TRUE : FALSE;
}

static SOCKET nonoverlapped_socket(void)
{
	int opt = SO_SYNCHRONOUS_NONALERT;
	
	setsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE,
			   (char *)&opt, sizeof opt);
	return socket(PF_INET, SOCK_STREAM, 0);
}

/* \Pbgt@CXg[쐬 */
static BOOL sock2fp(SOCKET sock, FILE **rdfp, FILE **wtfp)
{
	int fd;
	if (!rdfp && !wtfp)
		return FALSE;
	
	/* \Pbgɑ΂ _open_osfhandle  Win9x & VC++ ł͓Ȃ
	   iMS Knowledge Base  Article ID: Q139801 QƁj */
	fd = _open_osfhandle((long)sock, _O_BINARY);
	if (fd >= 0) {
		if (rdfp)
			*rdfp = _fdopen(fd, "r");
		if (wtfp)
			*wtfp = _fdopen(fd, "w");
		if ((!rdfp || *rdfp) && (!wtfp || *wtfp))
			return TRUE;

		if (rdfp)
			fclose(*rdfp);
		if (wtfp)
			fclose(*wtfp);
		close(fd);
	}
	return FALSE;
}

/* host,portɐڑA\PbgɑΉt@CXg[쐬 */
BOOL clientsock(const char* host, int port, FILE **rdfp, FILE **wtfp)
{
	SOCKET sock = nonoverlapped_socket();
	if (sock != INVALID_SOCKET) {
		if (connectto(host, port, sock) && sock2fp(sock, rdfp, wtfp))
			return TRUE;
		closesocket(sock);
	}
	return FALSE;
}

/* w肳ꂽ|[glisten\PbgԂ */
SOCKET serversock(int port)
{
	SOCKET sock;
	struct sockaddr_in sin;
	
	sock = nonoverlapped_socket();
	if (sock == INVALID_SOCKET)
		return sock;

	sin.sin_family = AF_INET;
	sin.sin_port = htons((unsigned short)port);
	sin.sin_addr.s_addr = htonl(INADDR_ANY);
	if (bind(sock, (struct sockaddr *)&sin, sizeof(sin)) == 0 &&
		listen(sock, SOMAXCONN) == 0)
		return sock;
	else {
		int e = WSAGetLastError();
		closesocket(sock);
		WSASetLastError(e);
		return INVALID_SOCKET;
	}
}

/* accept\PbgɑΉt@CXg[쐬
   serversockō쐬\Pbgn */
BOOL acceptfp(SOCKET lsock, struct sockaddr *addr, int *addr_len,
			  FILE **rdfp, FILE **wtfp)
{
	SOCKET csock = accept(lsock, addr, addr_len);
	if (csock != INVALID_SOCKET) {
		if (sock2fp(csock, rdfp, wtfp))
			return TRUE;
		closesocket(csock);
	}
	return FALSE;
}

/* fprintffflush */
int fprintf_f(FILE *fp, const char* fmt, ...)
{
	int r;
	va_list argptr;
	va_start(argptr, fmt);
	r = vfprintf(fp, fmt, argptr);
	va_end(argptr);
	fflush(fp);
	return r;
}
